# -*- coding: utf-8 -*-
"""
Created on Thu May  5 17:27:38 2022

@author: Richter

testfile for operating with json-files

"""
#%% import moduls
import json

#%% define functions
def findkeys(node, kv):
    '''
    https://stackoverflow.com/questions/9807634/find-all-occurrences-of-a-key-in-nested-dictionaries-and-lists 

    Parameters
    ----------
    node : TYPE
        DESCRIPTION.
    kv : TYPE
        DESCRIPTION.

    Yields
    ------
    TYPE
        DESCRIPTION.

    '''
    if isinstance(node, list):
        for i in node:
            for x in findkeys(i, kv):
               yield x
    elif isinstance(node, dict):
        if kv in node:
            yield node[kv]
        for j in node.values():
            for x in findkeys(j, kv):
                yield x
                
#%% main script
with open("test_data.json","r+") as file:
    data = json.load(file)

a = data.keys()
#print(a)

# read out key - value - pairs
for i in a:
    key = data[i]
    for j in range(0,len(key)):
        #print(j)
        dic = key[j]
        attrs = list(dic.keys())
        for x in attrs:
            name = list(findkeys(dic, x))
            #print("Maschinenart", i, "Das Attribut",x, "hat den Wert", name)

# find specific data
machine = "Pumps"
attribut = "Efficiency"

data_pumps = data[machine]
print(len(data_pumps))
for c in range(0,len(data_pumps)):
    name_pump = list(findkeys(data_pumps[c], "Name"))
    efficiency_pump = list(findkeys(data_pumps[c], attribut))
    print("Die Pumpe",str(name_pump),"besitzt den Wirkungsgrad", efficiency_pump)